# The Rust Testbench for FireDBG

Each sub-directory is a Cargo workspace. Please open each folder in VS Code with "Open Folder ...". For convenience, each example already contains a sample run (where they're under `xxx/firedbg/target/`).

## Basics

1. [`getting-started`](getting-started) ![](getting-started/screenshot.png)
1. [`roll_dice`](roll_dice) ![](roll_dice/screenshot.png)

## Algorithms

1. [`quicksort`](quicksort) ![](quicksort/screenshot.png)
1. [`mergesort`](mergesort) ![](mergesort/screenshot.png)

## File IO

1. [`rust-csv`](rust-csv) ![](rust-csv/screenshot.png)
1. [`cargo-expand`](cargo-expand) ![](cargo-expand/screenshot.png)
1. [`sea-query-rusqlite`](sea-query-rusqlite) ![](sea-query-rusqlite/screenshot.png)

## Multi-threaded

1. [`multi-thread-matrix`](multi-thread-matrix) ![](multi-thread-matrix/screenshot.png)

## Graphical

1. [`sudoku`](sudoku) ![](sudoku/screenshot.png)
1. [`tic_tac_toe`](tic_tac_toe) ![](tic_tac_toe/screenshot.png)
1. [`bubble-code`](bubble-code) ![](bubble-code/screenshot.png)